#include "connect.hpp"

ConnectPane::ConnectPane(Window *p) : Pane(p) {
	setSizeWithParent();
	create();
}

int ConnectPane::draw(DrawEvt *de) {
	canvas()->lock();
	for(int i=0; i < count - 1; i++)
		for (int j = i; j < count; j++) {
			canvas()->moveTo(points[i]);
			canvas()->lineTo(points[j]);
		}
	canvas()->unlock();
	return 1;
}


int ConnectPane::mouseMove(MouseMoveEvt *me) {
	canvas()->lock();
	if (down && count < 2000) {
		points[count++] =  (Point)*me;
		canvas()->pixel((Point)*me, Color(BLACK));
	}
	canvas()->unlock();
	return 1;
}

int ConnectPane::mouseButtonDown(ButtonEvt *be) {
	canvas()->lock();
	if (be->isButtonDown(1) && !down) {
		down=1;
		count=0;
		canvas()->setDirty();
		points[count++] = (Point)*be;
		canvas()->pixel((Point)*be, Color(BLACK));
	}
	canvas()->unlock();
	return 1;
}

int ConnectPane::mouseButtonUp(ButtonEvt *be) {
	canvas()->lock();
	if (be->isButton(1))
	{	down=0;
		canvas()->setDirty();
	}
	canvas()->unlock();
	return 1;
}
	
int ConnectPane::size(SizeEvt *) {
	canvas()->lock();
	canvas()->setDirty();
	canvas()->unlock();
	return 0;
}

MainFrame::MainFrame() : AppFrame("zApp Connect Demo") {
	create();
	image = new ConnectPane(this);
}

void App::main() {
#ifdef MEWEL
  if (WinOpenGraphics(0x10) != TRUE)
  {
    MessageBox(NULLHWND, "Can't go into graphics mode", "Checker", MB_OK);
    return;
  }
#endif
	MainFrame *p=new MainFrame();
	app->go();
	delete p;
#ifdef MEWEL
  WinCloseGraphics();
#endif
}
